package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMPurchangeHis;
import cn.ibizlab.eam.core.eam_core.filter.EMPurchangeHisSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPurchangeHis] 服务对象接口
 */
public interface IEMPurchangeHisService extends IService<EMPurchangeHis>{

    boolean create(EMPurchangeHis et) ;
    void createBatch(List<EMPurchangeHis> list) ;
    boolean update(EMPurchangeHis et) ;
    void updateBatch(List<EMPurchangeHis> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMPurchangeHis get(String key) ;
    EMPurchangeHis getDraft(EMPurchangeHis et) ;
    boolean checkKey(EMPurchangeHis et) ;
    boolean save(EMPurchangeHis et) ;
    void saveBatch(List<EMPurchangeHis> list) ;
    Page<EMPurchangeHis> searchDefault(EMPurchangeHisSearchContext context) ;
    List<EMPurchangeHis> selectByEmitempuseid(String emitempuseid) ;
    void removeByEmitempuseid(String emitempuseid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMPurchangeHis> getEmpurchangehisByIds(List<String> ids) ;
    List<EMPurchangeHis> getEmpurchangehisByEntities(List<EMPurchangeHis> entities) ;
}


